# read and plot OSO tags.R
# ---  SETUP ----
library(rScott); # uses Rot8() to shift a vector
library(ggplot2)
options(digits=5,show.error.locations=T,stringsAsFactors=F,show.signif.stars=F)
# --- LOCAL FUNCTIONS
SetPar=function() par(
    oma=c(2,2,2,1),    # room for marginal titles, 2 lines
    mar = c(2,2,1,0),  # spacing between plots
    mgp = c(1,0,0),    # axis numbers close to axis
    tcl = 0.2,         # ticks inside
    xaxs = "i",yaxs = "i" # needs xlim, ylim
);

Clr=rgb(0,50,50,30, maxColorValue = 100)

Margins=function(a,fnc=sum,...){  # adds right-hand col and bottom row
    a=cbind(a,apply(a,1,fnc,...));
    a=rbind(a,apply(a,2,fnc,...)); return(a);
}
WhichLagged = function(x,lag){
    # lag = -1 gives first of ALL repeated records
    # example: WhichLagged( c(1,2,2,3,4,4,4,5) ,-1) # 2,5,6
    j= x == Rot8(x,lag) # from library rScott
    return(which(j))
}

DOY=function(day,month,year=NULL){
    if(month < 1 || month > 12) stop("DOY: month is wrong")
    if(day < 1 || day > 31) stop("DOY: day is wrong")
    doy=day+ c(0,31,59,90,120,151,181,212,243,273,304,334)[month]
    #cumsum(c(0,31,28,31,30,31,30,31,31,30,31,30,31))
    if(is.null(year))return(doy)
    if((year %% 4 == 0) && month > 2) return(doy+1)
    return(doy)
}
DOY_US_date = function(x){
    dt.list=strsplit(x,"/"); # date strings: "5/5/2015", "5/24/2015", ...
    dt.vec=as.numeric(unlist(dt.list));  #    5 5 2015    5 24 2015 ...
    j=3*(0:(length(x)-1)) # 0  3  6  9 12 15 ...
    doy=DOY(dt.vec[j+2],dt.vec[j+1],dt.vec[j+3]) # day, month, year (leap?)
    res=list(doy=doy, day=dt.vec[j+2], month=dt.vec[j+1], year=dt.vec[j+3])
    return(res)
}
PlotID= function(txt) legend(x=lp.x,y=lp.y,legend=txt,cex=1.5,bty="n");
#
Pnull= function(txt) {
    # makes an empty plot with an ID by no axis labels
    # looks for xlim, ylim, lp.x, lp.y
    plot(1,1,type="n",ylim=ylim,xlim=xlim,xlab="",ylab="");
    PlotID(txt);
}
#
Taylor = function(elapsed, advect, diffuse){
    Dt= elapsed*4.0*diffuse^2
    a=exp(-(elapsed-advect)^2/Dt)/sqrt(pi*Dt)
    return(a)
}
#
Taylor_fit_lnorm= function(par,observed,elapsed){
    # advection-diffusion with time-dependent diffusion
    # elapsed > 0 else NA and not meaningful.
    # diffuse is a standard deviation for interpretability.
    # Large diffuse: arrivals extended, mass not conserved.
    # coded from (1/sqrt(4*pi*D*t)) * exp( (-(t-U)^2)/(4*D*t))
    advect=par[1]; diffuse= par[2]; sigma= par[3]
    if(any(elapsed<0.01))stop("ERROR Taylor_p: elapsed <= 0");
    Dt= elapsed*4.0*diffuse^2
    loga=  -(elapsed-advect)^2/Dt - log(pi*Dt)*0.5 # predicted
    loga= loga+log(sum(observed))
    # should observed = 0 be scored? no, gives -Inf
    j=observed > 0
    score=-sum(dlnorm(observed[j],loga[j],sigma,log=TRUE));
    return(score);
}
#
Taylor_fit_poisson= function(par,observed,elapsed){
    # advection-diffusion with time-dependent diffusion
    # elapsed > 0 else NA and not meaningful.
    # diffuse is a standard deviation for interpretability.
    # Large diffuse: arrivals extended, mass not conserved?
    # coded from (1/sqrt(4*pi*D*t)) * exp( (-(t-U)^2)/(4*D*t))
    # sum of predicted same as sum observed; same sample size.
    advect=par[1]; diffuse= par[2]; # Poisson variance = mean
    if(any(elapsed<0.01))stop("ERROR Taylor_p: elapsed <= 0");
    Dt= elapsed*4.0*diffuse^2
    a=exp(-(elapsed-advect)^2/Dt)/sqrt(pi*Dt) # proportion
    a= a*sum(observed) # non-integer prediction
    #  observations can only be integers >= 0
    # should observed = zero be included? No, stragglers lost.
    j=observed > 0
    score=-sum(dpois(observed[j],a[j],log=TRUE));
    return(score);
}
#
Hessian_SE=function(a) sqrt(abs(diag(solve(a$hessian))))
#
FilledStep <- function(x,y,colr=NULL){
    xp=c(rep(x,each=2),0);
    yp=c(0,rep(y,each=2));
    #rgb(t(col2rgb("skyblue")), alpha=125,maxColorValue=255)# "#87CEEB7D"
    #rgb(t(col2rgb("tan1")), alpha=125,maxColorValue=255)# "#FFA54F7D"
    if(is.null(colr)) colr= "#87CEEB7D" # skyblue, half density.
    polygon(x=xp,y=yp, col=colr)
}
#
BelowDiagonal= function(x){
    # result is by columns
    # example: BelowDiagonal(matrix(1:9,ncol=3)) # 2,3,6
    if(! is.matrix (x)) stop("BelowDiagonal: arg is not a matrix");
    n=dim(x)[1];m=dim(x)[2]
    y=numeric((n-1)*(m-1)) # excessive
    k=0
    for (irow in 2:n){
        for (jcol in 1:(irow-1)){
            k=k+1
            y[k]=x[irow, jcol]
        }
    }
    return(y[1:k]) # trim excess
}
#
# ----------------- READ DATA --------------
folder = "/Users/Scott/Documents/Projects/DFO - OK/Data"
file = "OSO smolt tags.csv"
a = read.csv(paste(folder,file,sep="/")) # set options(stringsAsFactors=F)
dim(a);a[1,]; # 37,438 rows 12 cols
# 1  1 Tag.Code 384.3B23A48D32
# 2  2 Event.Type.Name  Mark/Release
# 3  3 Event.Site.Name  SKATAL - SKA - Release into Tailrace
# 4  5 Tag.Type.Value 12mm
# 5  6 Event.Site.RKM.Value 858.177
# 6  - Event.Site.RKM.Total 1035 (deleted later)
# 7  7 Mark.Rear.Type.Name  Wild or Natural
# 8  8 Event.Date.MMDDYYYY  4/29/2015
# 9  9 Release.Date.MMDDYYYY 4/29/2015
#10 10 Release.Site.Name SKATAL - SKA - Release into Tailrace
#11 11 CTH.Count 1
#12  4 Event.Time.Min 04/29/2015 09:52:00
# --- subset columns, rename, reduce
a1=as.data.frame(a[,c(1,2,3,12,4,5,7,8,9,10)]) # 10 columns
names(a1)=c("tag", "event", "site", "event.time","tag.type", "eventRKM", "reared", "event.date","release.date","release.site")
# what have we got here?
table(a1$event);
# Mark/Release         Mort          Obs        Recap
#        26522          284        10427          250
sort(unique(a1$release.site)) # 6 of these
# [1] "OSOYBR - Osoyoos Lake Narrows Hwy 3 Bridge"
# [2] "OSOYOL - Osoyoos Lake"
# [3] "SHINGC - Shingle Creek - tributary to Okanagan River (Canada)"
# [4] "SKA - Skaha Dam"
# [5] "SKAHAL - Skaha Lake"
# [6] "SKATAL - SKA - Release into the Tailrace within 0.5 km downstream of Dam"#
sort(unique(a1$site)) # see duplicated() to get indices
# [ 1] "B2J - Bonneville PH2 Juvenile"
# [ 2] "BADGEI - Badger Island, Columbia River"
# [ 3] "BCC - BON PH2 Corner Collector"
# [ 4] "BO1 - Bonneville Bradford Is. Ladder"
# [ 5] "BO2 - Bonneville Cascades Is. Ladder"
# [ 6] "BO3 - Bonneville WA Shore Ladder/AFF"
# [ 7] "BO4 - Bonneville WA Ladder Slots"
# [ 8] "BON - Bonneville Dam Complex"
# [ 9] "CBLAIS - Central Blalock Island, Columbia R, ~ Boardman OR"
# [10] "COLR4 - Columbia R - Bonneville to John Day km 234-347"
# [11] "CRESIS - Crescent Island, Columbia River"
# [12] "DRM - Deschutes River mouth"
# [13] "ESANIS - East Sand Island, Columbia River"
# [14] "JDJ - John Day Dam Juvenile"
# [15] "LMILIS - Little Miller Island, Columbia River"
# [16] "LMJ - Lower Monumental Dam Juvenile"
# [17] "MC1 - McNary Oregon Shore Ladder"
# [18] "MC2 - McNary Washington Shore Ladder"
# [19] "MCJ - McNary Dam Juvenile"
# [20] "MCN - McNary Dam"
# [21] "MRC - Methow River at Carlton"
# [22] "OKANR - Okanogan River"
# [23] "OKC - Okanagan Channel at VDS-3"
# [24] "OKL - Lower Okanogan Instream Array"
# [25] "OKS - Shingle Creek"
# [26] "OSOYBR - Osoyoos Lake Narrows Hwy 3 Bridge"
# [27] "OSOYOL - Osoyoos Lake"
# [28] "PD7 - Columbia River Estuary rkm 70"
# [29] "POTHOL - Potholes Reservoir, Grant County, Washington"
# [30] "PRA - Priest Rapids Adult"
# [31] "PRDTAL - PRD - Release into Tailrace < 0.5 km downstream"
# [32] "RIA - Rock Island Adult"
# [33] "RICHIS - Richland Island, Columbia River"
# [34] "RIS - Rock Island Dam"
# [35] "RISFWC - Rock Island Forebay Waterbird Colony"
# [36] "RRE - Rocky Reach Dam"
# [37] "RRF - Rocky Reach Fishway"
# [38] "RRJ - Rocky Reach Dam Juvenile"
# [39] "SHINGC - Shingle Creek, tributary Okanagan River Canada"
# [40] "SKA - Skaha Dam"
# [41] "SKA - Skaha Dam Fish Ladder"
# [42] "SKAHAL - Skaha Lake"
# [43] "SKATAL - SKA - Release into Tailrace < 0.5 km downstream"
# [44] "TD1 - The Dalles East Fish Ladder"
# [45] "TD2 - The Dalles North Fish Ladder"
# [46] "TWX - Estuary Towed Array (Exp.)"
# [47] "WANTAL - WAN - Release into Tailrace < 0.5 km downstream"
# [48] "WEA - Wells Dam, DCPUD Adult Ladders"
# [49] "ZSL - Zosel Dam Combined"
a1$site=        substr(a1$site,        1,6) # shorter names
a1$release.site=substr(a1$release.site,1,6)
j1=substring(a1$site,        4,6) == " - "; # as in "RRJ - "
j2=substring(a1$release.site,4,6) == " - ";
a1$site[j1]        =substr(a1$site[j1],        1,3) # and shorter
a1$release.site[j2]=substr(a1$release.site[j2],1,3)

# .. all tag records have the release site. dissect this.
b=table(paste(a1$release.site,a1$event,sep=":"));
# OSOYBR:Mark/Release  9984
# OSOYBR:Mort           158
# OSOYBR:Obs           4256
# OSOYBR:Recap          106
# OSOYOL:Mark/Release  3101
# OSOYOL:Mort            15
# OSOYOL:Obs           1330
# OSOYOL:Recap           29
# SHINGC:Mark/Release    11
# SHINGC:Obs              1
# SKA:Mark/Release   870
# SKA:Mort            13
# SKA:Obs            321
# SKA:Recap            3
# SKAHAL:Mark/Release  2338
# SKAHAL:Mort            13
# SKAHAL:Obs            994
# SKAHAL:Recap           29
# SKATAL:Mark/Release 10218
# SKATAL:Mort            85
# SKATAL:Obs           3525
# SKATAL:Recap           83
rs=as.vector(b); 22
rs=c(rs[1:10],0,0, rs[11:22]); # 24, fill the table
rsm=matrix(rs, nrow=6, byrow=TRUE);
dimnames(rsm)=list(released=c("OSOYBR","OSOYOL","SHINGC","SKA","SKAHAL","SKATAL"),event=c("released", "mort","obs","recap"))
Margins(rsm) # default is sum
#     released mort   obs recap   sum
# OSOYBR  9984  158  4256   106 14504
# OSOYOL  3101   15  1330    29  4475
# SHINGC    11    1     0     0    12
# SKA      870   13   321     3  1207
# SKAHAL  2338   13   994    29  3374
# SKATAL 10218   85  3525    83 13911
#    sum 26522  285 10426   250 37483
#
table(a1$site[a1$event=="Obs"]) # all years, and >= 1 year post release
# B2J  BCC  BO1  BO2  BO3  BO4  DRM  JDJ  LMJ  MC1
# 349  733   83   15   89  153    4  534    1  105
# MC2  MCJ  MRC  OKL  OKS  PD7  PRA  RIA  RRF
#  80 1327    1   260   1    7  161  115  144
# RRJ  SKA  TD1  TD2  TWX  WEA  ZSL
# 5403   10  143   68  231  159  186

# remove OKC detetions, upstream of Osoyoos Lake
j=a1$site == "OKC"& a1$event =="Obs"; sum(j); a1=a1[!j,] # 65 37,418

# -- day of year
x1=a1$event.date[a1$event =="Obs"] # 10362 detections
x2=a1$event.time[a1$event =="Obs"]
x3=a1$release.date[a1$event =="Obs"]
time.eventdate=strptime(x1, "%m/%d/%Y")
time.eventtime=strptime(x2, "%m/%d/%Y %T")
time.releasedate=strptime(x3, "%m/%d/%Y")
# check redundant date info.
sum(time.eventdate$year != time.eventtime$year); # 0 OK
sum(time.eventdate$yday != time.eventtime$yday); # 0 OK
yr=time.releasedate$year; ye=time.eventdate$year;
j=ye > yr; sum(j);# 1480 of detections >= 1 year later
x=(ye-yr)[j]; table(x); # 1 year: 506; 2 years: 944; 3 years: 30.
# delete obs >= 1 year after release
eventtime=strptime(a1$event.time, "%m/%d/%Y %T") # 37418
a1$event.doy=eventtime$yday +1 # 0:365 or 1:366?
a1$event.year=eventtime$year+1900 # 115 or 2015?
a1$event.hour=eventtime$hour # 0 to 23 (Zulu)
releasedate=strptime(a1$release.date, "%m/%d/%Y") # 37418
a1$release.doy=releasedate$yday +1 # 0:365 or 1:366?
a1$release.year=releasedate$year+1900 # 115 or 2015?
j=a1$event.year > a1$release.year # 1519 includes mort and recapture
a1=a1[!j,] # 35889 without following year detections
    #a1$event.hour=event.hour[!j];
    #a1$event.year  =event.year[!j];  a1$event.doy=  event.doy[!j];
    #a1$release.year=release.year[!j];a1$release.doy=release.doy[!j];

SetPar(); par(mfrow=c(3,2))
dams=c("ZSL","RRJ", "MCJ","JDJ","B2J","TWX")
for(dam in dams){
    x=a1$event.hour[a1$site==dam & a1$event=="Obs"]
    hist(x, breaks=24, xlim=c(0,24), col="skyblue",
     main=paste("Hour Detected at",dam), xlab="Hour");box()
}
a1=a1[a1$event == "Obs",] # 8882 15, no "Mark/Release", "Mort", "Recap".
a1=a1[order(a1$tag,a1$event.doy),]
folder = "/Users/Scott/Documents/Projects/DFO - OK/OK Data from R"
file = "OSO tags.Rdata"
PITtags=a1;
#save(PITtags,file=paste(folder,file,sep="/"))
# ------------- Explore ----------------
folder = "/Users/Scott/Documents/Projects/DFO - OK/OK Data from R"
file = "OSO tags.Rdata"
load(file=paste(folder,file,sep="/"))# 8882 rows 15 cols
a1=PITtags

elapsed = a1$event.doy-a1$release.doy # 29. reported to Skyler Folks.
j0=elapsed <=0; sum(j0) #  29 < 0  reported to Skyler Folks.
sum(elapsed >100) # 0
a1=a1[!j0,] # 8853 removed detected before released.

SetPar(); par(mfcol=c(2,1))
hist(elapsed[!j0],col="skyblue",main="Time From Release to All Detections",
     xlab="Days After Release", ylab="");box() # almost all 5-45 days
hist(a1$event.doy[!j0], col="skyblue", main="Date of Detection",
     xlab="Day of the Year", ylab="");box() #almost all 110-150, max 125-135
mtext("Frequency",2,outer=T, line =-1,cex=1.5)

# --- repeated detect ----
first= WhichLagged(a1$tag,-1)
# index to find the first of every repeat:
#   WhichLagged(c("a","b","b","b","c"),-1) -> 2,3
# does NOT include third and fourth detections
second= first+1
third= WhichLagged(a1$tag,2); # tag run starts at third-2
fourth=WhichLagged(a1$tag,3);
# WhichLagged(obs$tag,4)  # integer(0), zero smolts detected five times
cat("number of second obs:", length(second),
 "\n number of third obs:", length(third),
 "\n number of fourth obs:",length(fourth), "\n")
# number of second obs: 1553
# number of third obs: 171
# number of fourth obs: 9

for (j in fourth){print(obs[j,1]);print(obs[(j-3):j,c(3,6,12)])}
# [1] "3D9.1C2D6D5625"
# site eventRKM event.doy
# 4875 RRJ -       763       134
# 4874 MCJ -       470       143
# 4873 JDJ -       347       145
# 4876 TWX -       075       148
# [1] "3D9.1C2DC98D58"
# site eventRKM event.doy
# 13353 RRJ -       763       133
# 13352 MCJ -       470       137
# 13350 JDJ -       347       139
# 13351 JDJ -       347       140   *** same place next day
# [1] "3DD.003B9B576C"
# site eventRKM event.doy
# 14450 RRJ -       763       137
# 14442 JDJ -       347       142
# 14439 B2J -       234       143
# 14452 TWX -       075       145
# [1] "3DD.003BA44D46"
# site eventRKM event.doy
# 19072 RRJ -       763       129
# 19071 MCJ -       470       135
# 19070 JDJ -       347       137
# 19069 BCC -       234       139
# [1] "3DD.00775802DE"
# site eventRKM event.doy
# 26217 OKL -   858.025       113
# 26218 RRJ -       763       115
# 26216 MCJ -       470       120
# 26215 BCC -       234       125
# [1] "3DD.007758D522"
# site eventRKM event.doy
# 29938 RRJ -       763       126
# 29937 MCJ -       470       131
# 29936 JDJ -       347       132
# 29935 B2J -       234       134
# [1] "3DD.007758E645"
# site eventRKM event.doy
# 30416 RRJ -       763       129
# 30415 MCJ -       470       134
# 30414 JDJ -       347       137
# 30413 BCC -       234       138
# [1] "3DD.0077594498"
# site eventRKM event.doy
# 32312 RRJ -       763       113
# 32311 MCJ -       470       117
# 32310 BCC -       234       121
# 32313 TWX -       075       123
# [1] "3DD.00777CCD8F"
# site eventRKM event.doy
# 33144 RRJ -       763       132
# 33143 MCJ -       470       136
# 33142 JDJ -       347       139
# 33141 BCC -       234       140
travel= data.frame(
    tag=a1$tag[first],count="1:2", year=a1$event.year[first],
    site1=a1$site[first],     site2=a1$site[second],
    rkm1=a1$eventRKM[first],  rkm2=a1$eventRKM[second],
    doy1=a1$event.doy[first], doy2=a1$event.doy[second],
    hour1=a1$event.hour[first], hour2=a1$event.hour[second])
dim(travel) # 1553 11
a=  data.frame(count="2:3",
    tag=a1$tag[third], year=a1$event.year[third],
    site1=a1$site[third-1],     site2=a1$site[third],
    rkm1=a1$eventRKM[third-1],  rkm2=a1$eventRKM[third],
    doy1=a1$event.doy[third-1], doy2=a1$event.doy[third],
    hour1=a1$event.hour[third-1], hour2=a1$event.hour[third])
b=  data.frame(count="3:4",
    tag=a1$tag[fourth-1], year=a1$event.year[fourth],
    site1=a1$site[fourth-1],     site2=a1$site[fourth],
    rkm1=a1$eventRKM[fourth-1],  rkm2=a1$eventRKM[fourth],
    doy1=a1$event.doy[fourth-1], doy2=a1$event.doy[fourth],
    hour1=a1$event.hour[fourth-1], hour2=a1$event.hour[fourth])
travel=rbind(travel,a,b) # 1733 14
travel$sep=as.numeric(travel$rkm1) - as.numeric(travel$rkm2);
travel$ftt.day= travel$doy2 - travel$doy1;
travel$ftt.hour=travel$ftt.day*24 + travel$hour2 - travel$hour1;
j=travel$sep < 1 ;sum(j) # 40, 25 from 1:2, 14 from 2:3, 1 from 3:4
tmp=travel[j,] # inspect: same place next day, some before then after midnight
travel=travel[!j,] # 1694 14
j=travel$ftt.day < 1; sum(j) #  0, cleaned up by deleting sep < 1
j=travel$ftt.day > 30;sum(j) # 1
travel[which(j),] # tag=3DD.00777ED293 2016 ftt.day=60 days sep=416km RRH-JDJ
travel=travel[!j,] # deleted.  1527 rows left
travel$sep=round(travel$sep,0) # makes ZSL and OKL into the same place
travel$site1[travel$site1=="OKL"] = "ZSL"
x=travel$sep  # 16 different separations
y=travel$ftt.day
xy=data.frame(Distance = x, Time=y)
SetPar(); par(mfcol=c(1,1))
p <- ggplot(xy, aes(Distance,Time)) + theme_bw();
p+ geom_count()

# ---- read travel  ----
save(file=paste(folder,"PIT travel.Rdata",sep="/"),travel)
folder = "/Users/Scott/Documents/Projects/DFO - OK/OK Data from R"
load(file=paste(folder,"PIT travel.Rdata",sep="/")) # 1527 10
# NOTE this is all pairs of detections, 1:2, 2:3, and 3:4
# ---- years lumped ----
x=travel$sep; y=travel$ftt.day
a=table(x); a # counts at distance
#33  95 113 123 159 236 272 293 388 395 400 416 511 529 624 688
# 3  82  78  94  46 172   5 538  12  34   1 154  11 390   9  63
table(x[travel$count != "1:2"])  # third and fourth detections
#    95 113 123 159 236 272 293     395     416     529     688
#     1  30  31  16  56   2   9      10       3       6       1
b=sort(unique(x))# same as table categories: 33, 95, 113,,
b=b[a > 13] # just well sampled separations, smallest is n = 24
j=which(x %in% b, arr.ind = T); length(j) # 1651 from 1692
a=table(x[j]); a
# km:    95 113 123 159 236 293 395 416 529 688
# count: 82  78  94  16 172 538  34 154 390  63
xy=data.frame(Distance = x[j], Time=y[j])
p <- ggplot(xy, aes(Distance,Time)) + theme_bw() +
    xlab("Distance Traveled (km)")+
    ylab("Elapsed Time (days)");
p+ geom_count()
p <- ggplot(xy, aes(factor(Distance),Time)) + theme_bw() +
    xlab("Distance Traveled (km)")+
    ylab("Elapsed Time (days)");
p+geom_violin(col="blue",fill="skyblue")
# -- by hours
xh=data.frame(Distance = x[j], Time=travel$ftt.hour[j])
p <- ggplot(xh, aes(factor(Distance),Time)) + theme_bw() +
    xlab("Distance Traveled (km)")+
    ylab("Elapsed Time (hours)");
p+geom_violin(col="blue",fill="skyblue")

xy$Dist.f = factor(xy$Distance)
tbl=tapply(xy$Time, xy$Dist.f,Simple, do.print=F) # do not print
st=round(matrix(unlist(tbl),byrow=T, ncol=11),2)
st=cbind(b,st);
colnames(st) = c("Sep","N","Mean","SD","SE","CV","Med","MAD","Min","Q1","Q3","Max")
st
# messy output, hand edited to this table. MAD uses 1.4826
#      Sep   N  Mean   SD   SE   CV Med  MAD Min Q1 Q3 Max
# [1,]  95  82  2.67 0.99 0.11 0.37   2 1.48   1  2  3   6
# [2,] 113  78  1.60 0.49 0.06 0.31   2 0.00   1  1  2   2
# [3,] 123  94  2.64 1.29 0.13 0.49   2 0.00   1  2  3   9
# [4,] 159  46  1.83 0.38 0.06 0.21   2 0.00   1  2  2   2
# [5,] 236 172  3.91 0.87 0.07 0.22   4 0.00   3  3  4  10
# [6,] 293 538  4.96 1.66 0.07 0.33   5 1.48   3  4  6  18
# [7,] 395  34  6.35 1.67 0.29 0.26   6 1.48   5  5  7  11
# [8,] 416 154  6.90 1.82 0.15 0.26   6 1.48   4  6  8  14
# [9,] 529 390  8.74 1.66 0.08 0.19   8 1.48   5  8 10  15
# [10] 688  63 10.80 2.50 0.32 0.23  10 1.48   8  9 12  21
# Ordinary Linear Regression:
summary(lm(st[,3]~b)) # mean travel time vs distance
#            Est         SE
# int   0.352     0.314
# slope 0.01539   0.000875
# residuals: SD = 0.523,  r^2 = 97.5%
# F 309 on 1 and 8 DF,  Pr > F = 1.1e-07
1 / (0.01539 + 0.000875*c(-2,0,2)) #  73.314 64.977 58.343
# this is 65 km/day with 95% CL 58.3 to 73.3
# at 1 BL/s, 10 cm smolts swim 0.1*86400/1000 = 8.64 km/day
# so flow must be about 65-8.6 = 56.4 km/day = 2.35 kph

# linear regression weighted by SD
summary(lm(st[,3]~b, weights= st[,4]^-2 ))
#          Est        SE
# int     -0.333   0.3795
# slope    0.01650  0.00188
# residuals SD = 0.747, r^2 = 90.6%
# F 77 on 1 and 8 DF,  Pr  2.2e-05
1 / (0.0165+ 0.0018*c(-2,0,2)) # 77.519 60.606 49.751
# weighted by sample size
summary(lm(st[,3]~b, weights= st[,2])) # weight is count
#          Est        SE
# int   0.3969   0.2565
# slope 0.01556  0.000686
# residuals SD = 4.36 r^2 = 98.5%
# F 515 on 1 and 8 DF, Pr = 1.5e-07
1 / (0.01556 + 0.000686*c(-2,0,2) ) # 70.482 64.267 59.060

# through origin, weighed by cases
summary(r1 <- lm(st[,3]~0+b, weights= st[,2])) # weighted by cases
# slope = 0.016528  SE = 0.000309
(rsq= 1-sum(r1$residuals^2)/sum( (st[,3] - mean(st[,3]))^2 )) # 96.9%
1 / (0.016528 + 0.000309*c(-2,0,2)) #78.555 60.790 49.579

velocity = st[,1]/st[,3]; round(velocity,1)
# 35.6 70.6 46.6 86.9 60.4 59.1 62.2 60.3 60.5 63.7
Simple(velocity) # mad uses 1.4826
# n     m     s    se    cv    md   mad   min    q1    q3   max
# 10  60.6  13.5  4.25 0.222  60.4  3.72  35.6  59.4  63.3  86.9
Simple(velocity[5:10])
# n  m    s    se     cv   md  mad min    q1   q3  max
#   61 1.65 0.674 0.027  60.4 1.13 59.1 60.3 61.8 63.7

# physical locations of separations
names(travel)
#[ 1] "tag" "count" "year" "site1"   "site2"
#[ 6] "rkm1" "rkm2" "doy1" "doy2"  "hour1"
#[11] "hour2" "sep" "ftt.day" "ftt.hour"
separation=sort(unique(travel$sep));
j=match(separation,travel$sep); length(j) # 16
site.sep=travel[j,c(3:5,12)] # first matches
# row year site1 site2 sep
# 234 2015   RRJ   RIA  33 # three to delete
# 12  2015   ZSL   RRJ  95
# 25  2015   JDJ   B2J 113
# 127 2014   MCJ   JDJ 123
# 3   2015   B2J   TWX 159
# 15  2015   MCJ   BCC 236
# 190 2015   JDJ   TWX 272
# 2   2015   RRJ   MCJ 293
# 372 2014   ZSL   MCJ 388
# 44  2015   MCJ   TWX 395
# 219 2013   MCJ   PD7 400 # one to delete
# 7   2015   RRJ   JDJ 416
# 658 2015   ZSL   JDJ 511
# 4   2015   RRJ   BCC 529
# 1   2015   ZSL   BCC 624
# 9   2015   RRJ   TWX 688

# ---- sep by year ----
tbl=table(travel[,c("sep","year")])
a= as.matrix(table(travel[,c("sep","year")]));
Margins(a)
# sep 2013 2014 2015 2016  sum
# 33     0    1    2    0    3
# 95     1    7   27   47   82
# 113    3    5   24   46   78
# 123    8   43    8   35   94
# 159    2    6   13   25   46
# 236   11   25   31  105  172
# 272    1    0    4    0    5
# 293   56  118   66  298  538
# 388    1    3    1    7   12
# 395    6   15    7    6   34
# 400    1    0    0    0    1
# 416   25   31   30   68  154
# 511    0    1    1    9   11
# 529   22   27  149  192  390
# 624    0    1    4    4    9
# 688   14    4   28   17   63
# sum  151  287  395  859 1692
years=2013:2016
k=logical(dim(travel)[1]) # F
for(i in 1:length(separation)) { # unique separations
  for (j in 1:4) {     # 2012+j = 2013:2016
    if(a[i,j] < 24) next;
    j1=(travel$sep==separation[i] & travel$year==years[j])
    k = k | j1; # accepted cases
  }
}
travel25=travel[k,] # >= 25 obs --> 1496 rows
f.sy=factor(paste(travel25$sep,travel25$year, sep="-"))
# 22 levels, alphabetic order. see levels()
a=tapply(travel25$ftt.day, f.sy,mean); a
# 113-2015 113-2016 123-2014 123-2016 159-2016
# 1.6667   1.6304   2.5581   2.7143   1.7200
# 236-2014 236-2015 236-2016 293-2013 293-2014
# 4.2400   4.0968   3.7333   4.5893   3.9915
# 293-2015 293-2016 416-2013 416-2014 416-2015
# 6.1061   5.1678   6.1600   5.9032   8.3667
# 416-2016 529-2014 529-2015 529-2016 688-2015
# 6.9853   7.4074   9.6846   8.2552  12.1071
# 95-2015  95-2016
# 3.6667   2.2340

a=unlist(tapply(travel25$ftt.hour, f.sy,Simple,do.print=F));
a=matrix(a,ncol=11, byrow=TRUE)[,c(1:3,8,9,6,10,11)] # 8 cols
case=levels(f.sy)
a= cbind(case,as.data.frame(a))
colnames(a)=c("case","n","m","s","min", "q1","med","q3","max")
# convert stats from hours to days, but not N.
a[,3:9]=a[,3:9]/24.0
pairs= c("JB", "JB", "MJ", "MJ", "BT", "MB", "MB", "MB", "RM", "RM", "RM", "RM", "RJ", "RJ", "RJ", "RJ", "RB", "RB", "RB", "RT", "ZR", "ZR")
a$pairs=pairs
dn=as.numeric(unlist(strsplit(case,"-")));#113,2015,113,2016,,
j=seq(1,length(dn)-1,2)
x.sep=dn[j]; # 113,113,123,,95,95;
x.year=dn[j+1]; # 2015,2016,2014,,
a$sep=x.sep; a$year=x.year
f.year=factor(x.year)
print(a,digits=2) # based on ftt.hour instead of ftt.day
#      case   n    m    s min   q1  med   q3  max pairs sep year
1  113-2015  24  1.7 0.17 1.4  1.5  1.8  1.8  1.9    JB 113 2015 *
2  113-2016  46  1.4 0.18 1.2  1.3  1.4  1.5  2.0    JB 113 2016 *
3  123-2014  43  2.6 1.24 1.7  2.0  2.2  2.6  6.6    MJ 123 2014 *
4  123-2016  35  2.8 1.33 1.8  2.1  2.5  2.9  9.1    MJ 123 2016 *
5  159-2016  25  1.7 0.10 1.5  1.6  1.7  1.8  1.9    BT 159 2016 *
6  236-2014  25  4.1 1.44 2.9  3.3  3.7  4.2  9.5    MB 236 2014
7  236-2015  31  4.2 0.57 3.1  3.8  4.1  4.4  5.8    MB 236 2015
8  236-2016 105  3.7 0.45 2.8  3.4  3.6  3.9  5.1    MB 236 2016
9  293-2013  56  4.8 1.31 3.1  3.8  4.4  5.1  8.4    RM 293 2013 *
10 293-2014 118  4.1 0.90 2.8  3.4  3.9  4.6  7.0    RM 293 2014 *
11 293-2015  66  6.0 1.30 3.4  5.3  5.8  6.3 10.0    RM 293 2015 *
12 293-2016 298  5.2 1.68 3.3  4.2  4.8  5.8 17.8    RM 293 2016 *
13 416-2013  25  6.5 1.04 5.2  5.6  6.3  6.7  9.3    RJ 416 2013
14 416-2014  31  6.2 1.30 4.5  5.4  5.6  6.5 10.2    RJ 416 2014
15 416-2015  30  8.4 1.58 6.0  7.3  8.2  8.5 13.5    RJ 416 2015
16 416-2016  68  7.1 1.66 5.2  6.1  6.4  8.0 13.4    RJ 416 2016
17 529-2014  27  7.5 1.52 6.0  6.5  7.0  7.5 13.3    RB 529 2014
18 529-2015 149  9.6 1.59 7.1  8.3  9.4 10.6 15.0    RB 529 2015
19 529-2016 192  8.2 1.20 6.1  7.5  8.0  8.8 14.7    RB 529 2016
20 688-2015  28 12.0 1.76 8.9 11.1 12.1 13.2 15.9    RT 688 2015
21  95-2015  27  3.5 0.74 1.9  3.1  3.5  3.8  5.9    ZR  95 2015 *
22  95-2016  47  2.0 0.46 1.5  1.7  1.8  2.3  3.6    ZR  95 2016 *

# predict multi-segment FTT as sum of one-segment FTTs
# multi-segment timings are dist(cumsum(0,ZR,RM,MJ,JB,BT))
segs=c("ZR","RM","MJ","JB","BT");
years= 2014:2016
ft.segs=matrix(nrow=3, ncol=5); #NAs
for (j in 1:length(segs)){
    for(k in 1:length(years)){
        b= a[ a$pairs == segs[j] & a$year == years[k], 3 ] # one mean ftt
        # if no match in table, is numeric with length 0, numeric(0)
        if(length(b) ==0) next # not in the table, leave as NA
        ft.segs[k,j] = b;
     }
}
# [1,]     NA 4.0833 2.6458     NA     NA
# [2,] 3.5083 6.0417     NA 1.6875     NA
# [3,] 2.0250 5.2500 2.8333 1.4083 1.6958

pred.ftt= function(x){
    nyears=dim(x)[1]; nsegs=dim(x)[2];
    y=array(dim=c(nyears, nsegs,nsegs)) # a matrix for each year, NAs
    for (i in nyears){
        for (j in 1:nsegs) {
            for(k in 2:j)
        }
    }
}
ft.2015= c(0., case=ZR] )

ft.2015 = c(0.,
    a[a$case== "95-2015",3], a[a$case=="293-2015",3], NA, a[a$case=="113-2015",3], NA)
    # no BT 2015, BON to TWX in table from N >= 25
    # no MJ 2015 so must use MB instead, allowing RM+MB
# 0.0000 3.5083 6.0417 1.6875     NA

ft.2016 = c( 0., # Z to Z, Z to R, R-M, M-B, B-T
    a[a$case== "95-2016",3], a[a$case=="293-2016",3],
    a[a$case=="123-2016",3], a[a$case=="113-2016",3],
    a[a$case=="159-2016",3]);
# no case for BT 2016
# 0 2.0250 5.2500 2.8333 1.4083 NA
cumsum(ft.2016)
#0.000, 2.025 7.275 10.108 11.517 13.213
(pred.ftt.2016=dist(cumsum(ft.2016)))
# 1       2       3       4       5
# 2  2.0250
# 3  7.2750  5.2500
# 4 10.1083  8.0833  2.8333
# 5 11.5167  9.4917  4.2417  1.4083
# 6 13.2125 11.1875  5.9375  3.1042  1.6958
pred.ftt.2016 = as.vector(pred.ftt.2016); # by columns
names(pred.ftt.2016) = c("ZR","ZM","ZJ","ZB","ZT","RM", "RJ","RB","RT","MJ","MB","MT","JB","JT","BT")
pred.ftt.2016=pred.ftt.2016[c(2:5,7:9,11:12,14)]
round(pred.ftt.2016,1) # units are days, 10 cases
#  ZM   ZJ   ZB   ZT   RJ   RB   RT   MB   MT   JT
# 7.3 10.1 11.5 13.2  8.1  9.5 11.2  4.2  5.9  3.1
obs.ftt.2016=c(NA, NA, NA, NA, a[13,3], a[19,3],a[20,3],a[8,3],NA,NA); # 10
cbind(pred.ftt.2016, obs.ftt.2016)
pred.ftt.2016 obs.ftt.2016
# ZM        7.2750           NA
# ZJ       10.1083           NA
# ZB       11.5167           NA
# ZT       13.2125           NA
# RJ        8.0833       6.4583
# RB        9.4917       8.2500
# RT       11.1875      11.9583
# MB        4.2417       3.6625
# MT        5.9375           NA
# JT        3.1042           NA
summary(lm(pred.ftt.2016 ~ obs.ftt.2016))
#              Estimate         SE       t Pr(>|t|)
# (Intercept)     2.059      1.391    1.48    0.277
# obs.ftt.2016    0.817      0.170    4.79    0.041
# Residuals SD = 1.03 on 2 degrees of freedom
# r^2=0.92, F(1,2)=22.9, p-value: 0.0409
pct.dif=round(100*pred.ftt.2016/obs.ftt.2016, 0);
pct.dif=pct.dif[!is.na(pct.dif)]; pct.dif; mean(pct.dif);sd(pct.dif)
# RJ  RB  RT  MB      112.5% sd=13
# 125 115  94 116


dn=as.numeric(unlist(strsplit(dimnames(a)[[1]],"-")));#113,2015,113,2016,,
j=seq(1,length(dn)-1,2)
x.sep=dn[j]; # 113,113,123,, 95,95;
x.year=dn[j+1]; # 2015, 2016, 2014,,
f.year=factor(x.year)
# -- reg by year
tapply(travel25$ftt.hour,f.year,Simple)
plot(xh=data.frame(Distance = Travel25$sep, Time=travel25$ftt.hour)
     p <- ggplot(xh, aes(factor(Distance),Time)) + theme_bw() +
         xlab("Distance Traveled (km)")+
         ylab("Elapsed Time (hours)");
     p+geom_violin(col="blue",fill="skyblue")
)
# through origin, weighed by cases. each detection
summary(r2 <- lm(travel25$ftt.hour]~0+b, weights= st[,2])) # weighted by cases
# slope = 0.016528  SE = 0.000309
(rsq= 1-sum(r1$residuals^2)/sum( (st[,3] - mean(st[,3]))^2 )) # 96.9%
1 / (0.016528 + 0.000309*c(-2,0,2)) #78.555 60.790 49.579


# --- 5 contiguous----
# single segments, independent estimates
# define segments using separation as criteria
# ZSL RRH 95, RRH MCN 293, MCN JDA 123, JDA BON 113, BON TWX 159.
# forget: RRH RIS 33, 3 detected; RIS MCN, 0; BON PD7, 0.
reaches=c("ZSL-RRH", "RRH-MCN", "MCN-JDA", "JDA-BON", "BON-TWX")
years=as.character(c( 2013:2016)) # "2013",
x=c(113,123,159,293,95); # this is how sep will sort as alpha
sum(x) #  783, 5 reaches, 6 detectors
river = c(5,4,2,1,3); # downstream order
x[river] # 95 293 123 113 159
x.mat=matrix(x[river], nrow=5,ncol=4, dimnames=list(reaches,years))

j1 = travel$sep %in% c(95,293,123,113,159); sum(j1); # 751 of 1527
oneReach= travel[j1,];
f.sy=factor(paste(as.character(oneReach$sep),
                  as.character(oneReach$year), sep="-"))
# factor with 20 levels. tables in alphabetic order of factor
a=matrix(tapply(oneReach$ftt, f.sy,length), ncol=4,byrow=TRUE); # count
b=matrix(tapply(oneReach$ftt, f.sy,mean  ), ncol=4,byrow=TRUE);
d=matrix(tapply(oneReach$ftt, f.sy,sd    ), ncol=4,byrow=TRUE);
b[a<5] = NA # sample sizes too small
d[a<5] = NA # sample sizes too small
v=x.mat/b[river,] # velocity km/day
a1 <- Margins(a[river,],sum );
b1 <- Margins(b[river,],mean, na.rm=TRUE)
d1 <- Margins(d[river,],mean, na.rm=TRUE)
v1 <- Margins(v,mean, na.rm=TRUE)

dimnames(a1)=list(reach=c(reaches,"sum"),year=c(years,"sum"))
dimnames(b1)=list(reach=c(reaches,"mean"),year=c(years,"mean"))
dimnames(d1)=list(reach=c(reaches,"mean"),year=c(years,"mean"))
a1;round(b1,2);round(d1,2);round(v1,1);
# reach     2013 2014 2015 2016 sum COUNT
# ZSL-RRH    1    7   26   47  81
# RRH-MCN   56  116   65  292 529
# MCN-JDA    6   31    5   21  63
# JDA-BON    3    3   16   26  48
# BON-TWX    2    3    9   16  30
# sum       68  160  121  402 751

# reach     2013 2014 2015 2016 mean MEAN TIME
# ZSL-RRH   NA 1.71 3.69 2.23 2.55
# RRH-MCN 4.59 4.00 6.11 5.17 4.97
# MCN-JDA 2.50 2.52 3.00 2.86 2.72
# JDA-BON   NA   NA 1.69 1.65 1.67
# BON-TWX   NA   NA 1.89 1.75 1.82
# mean    3.54 2.74 3.28 2.73 2.74

# reach   2013 2014 2015 2016 mean  SD
# ZSL-RRH   NA 0.49 0.84 0.63 0.65
# RRH-MCN 1.36 0.99 1.40 1.77 1.38
# MCN-JDA 0.55 1.29 0.71 1.71 1.06
# JDA-BON   NA   NA 0.48 0.49 0.48
# BON-TWX   NA   NA 0.33 0.45 0.39
# mean    0.95 0.92 0.75 1.01 0.79

# reach   2013 2014 2015 2016 mean VELOCITY
# ZSL-RRH   NA 55.4 25.7 42.5 41.2
# RRH-MCN 63.8 73.2 48.0 56.6 60.4
# MCN-JDA 49.2 48.9 41.0 43.0 45.5
# JDA-BON   NA   NA 67.0 68.3 67.6
# BON-TWX   NA   NA 84.2 90.9 87.5
# 56.5 59.2 53.2 60.3 60.5
vel=array(dim=c(5,4,3), dimnames=list(reaches, years, c("mean","5%","95%")))
se=d*a^-0.5; qn=c(0,2,-2); # standard error = SD/sqrt(n)
for(j in 1:3){
    vel[,,j]=x.mat /(b[river,]+qn[j]*se[river,]);
    print(round(Margins(vel[,,j],mean, na.rm=TRUE),1))
}
# mean 2013 2014 2015 2016 VELOCITY km/day
# ZSL-RRH   NA 55.4 25.7 42.5 41.2
# RRH-MCN 63.8 73.2 48.0 56.6 60.4
# MCN-JDA 49.2 48.9 41.0 43.0 45.5
# JDA-BON   NA   NA 67.0 68.3 67.6
# BON-TWX   NA   NA 84.2 90.9 87.5
# 56.5 59.2 53.2 60.3 60.5

# 5% 2013 2014 2015 2016
# ZSL-RRH   NA 45.6 23.6 39.3 36.2
# RRH-MCN 59.2 70.0 45.4 54.4 57.3
# MCN-JDA 41.7 41.3 33.9 34.1 37.8
# JDA-BON   NA   NA 58.6 61.3 60.0
# BON-TWX   NA   NA 75.3 80.6 77.9
# 50.4 52.3 47.4 53.9 53.8

# 95% 2013 2014 2015  2016
# ZSL-RRH   NA 70.6 28.2  46.4 48.4
# RRH-MCN 69.3 76.8 50.9  59.0 64.0
# MCN-JDA 59.9 59.9 52.0  58.3 57.5
# JDA-BON   NA   NA 78.0  77.2 77.6
# BON-TWX   NA   NA 95.4 104.2 99.8
# 64.6 69.1 60.9  69.0 69.5

# ---- vel plot ----
x1=cumsum(x[river]); # 95 388 511 624 783
x2= (c(0,x1[-5])+x1)/2.0 # 47.5 241.5 449.5 567.5 703.5
x2.m=matrix(x2,nrow=5,ncol=4)
SetPar()
plot(1,1, type="n", pch=20,xlim=c(0,800),ylim=c(0,100),
     xlab="Distance (km)",yaxt="n", ylab="Smolt Velocity (km/day)" )
detectors=c("ZSL", "RRH", "MCN", "JDA", "BON", "TWX")
axis(4, labels=F)
axis(3, at=c(0,x1), labels=detectors, cex.axis=0.75, las=3, hadj=-0.25)
at=seq(0,80,20); axis(2,at,at)
abline(v=x1, col="red",lty="dotted")
points(x2.m,vel[,,1],pch=20)
     labels=rep(substr(years,3,4), each=5) #
     pos=rep(c(2,4),10) #year labels left (odd) right (even)
text(x2.m,vel[,,1],labels=labels,pos=pos, cex=0.75, offset=0.25);
y2.m=vel[,,1] # extract mean vel from array of 3 matrices
for(year in 1:4) segments(x0=x2.m[1:4,year],y0=y2.m[1:4,year],
                          x1=x2.m[2:5,year],y1=y2.m[2:5,year],
                 col=Clr);

# ---- each detect ----
b=sort(unique(travel$sep));length(b); b; # 16 rounded to 1 km.
# 33  95 113 123 159 236 272 293 388 395 400 416 511 529 624 688
j=match(b,travel$sep) # single records
locations= travel[j,c(2:6,9)] # 16 rows 6 cols
locations$rkm1=round(as.numeric(locations$rkm1),0);
locations$rkm2=round(as.numeric(locations$rkm2),0);
dams.km=sort(unique(c(locations$rkm1,locations$rkm2)))
from.zsl= rev(858-dams.km) # 7 reaches
# 0  95 128 388 511 624 783 788
names(from.zsl)= c("ZSL", "RRH", "RIS", "MCN", "JDA", "BON", "TWX", "PD7")
dist(from.zsl)
# dam ZSL RRH RIS MCN JDA BON TWX
# RRH  95
# RIS 128  33
# MCN 388 293 260
# JDA 511 416 383 123
# BON 624 529 496 236 113
# TWX 783 688 655 395 272 159
# PD7 788 693 660 400 277 164   5
travel$rkm1=round(as.numeric(travel$rkm1),0);
travel$rkm2=round(as.numeric(travel$rkm2),0);
sort(travel$ftt,decreasing=T)[1:10]
# 21 19 18 16 16 15 15 15 15 15 longest ftt (but deleted 60)
plot(type="n",x=1,y=1,xlim=c(0,800),ylim=c(0,22),
     xlab="Downstream (km)",ylab="Travel Time (days)");
axis(4, labels=F)
axis(3, at = from.zsl[-8], labels=names(from.zsl[-8]), cex.axis =0.75, las=3, hadj=-0.25)
abline(v=from.zsl[-1], col="red",lty="dotted")
#j=sample(1:length(travel$rkm1),100) # some travel times
j = 1:length(travel$rkm1) # all
segments(x0=858-travel$rkm1[j], y0=0*j,
         x1=858-travel$rkm2[j],y1=travel$ftt[j], col=Clr)
points(x=858-travel$rkm2[j],y=travel$ftt[j], pch=20,cex=0.5)
points(from.zsl, 0*from.zsl,pch=20,col="red")

# --- three detects ----
# the 171 smolts detected three times (two travel times)
# use third detection to find preceeding
y3=obs[third,];  y2=obs[third-1,]; y1=obs[third-2,];
obs123 = data.frame(site1=y1$site,site2=y2$site,site3=y3$site,
  rk1=round(as.numeric(y1$eventRKM),0),
  rk2=round(as.numeric(y2$eventRKM),0),
  rk3=round(as.numeric(y3$eventRKM),0),
  doy1=y1$event.doy,doy2=y2$event.doy,doy3=y3$event.doy)
a= within(obs123, {sep1=rk1-rk2; sep2=rk2-rk3; ftt1=doy2-doy1;
    ftt2=doy3-doy2})
obs123=cbind(obs123,a)
# cleaning
sort(unique(obs123$sep1))
# 0  33  95 113 123 236 293 388 416 529
sort(unique(obs123$sep2))
113 123 159 236 272 293 395 416 529 688
j=obs123$sep1 < 10 ; sum(j) # 15
obs123=obs123[!j,];dim(obs123); # 156 22
sort(unique(obs123$ftt1)) ;sort(unique(obs123$ftt2)) ;
# 1  2  3  4  5  6  7  8  9 10 11 13
# 1  2  3  4  5  6  7  8  9 11
SetPar()
plot(type="n",x=1,y=1,xlim=c(0,800),ylim=c(0,22),
     xlab="Downstream (km)",ylab="Travel Time (days)");
axis(4, labels=F)
axis(3, at = from.zsl[-8], labels=names(from.zsl[-8]), cex.axis =0.75, las=3, hadj=-0.25)
abline(v=from.zsl[-1], col="red",lty="dotted")
for (j in 1:dim(obs123)[1] ){        # by 156 rows
    x0=858-as.numeric(obs123$rk1[j]) # first detection
    x1=858-as.numeric(obs123$rk2[j]) # second detection
    x2=858-as.numeric(obs123$rk3[j]) # second detection
    y0=0                             # start
    y1=obs123$ftt1[j]                # first arrival
    y2=y1+obs123$ftt2[j]             # second arrival
    segments(x0,y0,x1,y1,col=Clr)
    points(x1,y1,pch=20,cex=0.33)
    segments(x1,y1,x2,y2,col=Clr)
    points(x2,y2,pch=20,cex=0.33)
}
x=858-unique(obs123$rk1); y=0*x;points(x,y,pch=20,col="red")


# the nine-1 = 8 smolts detected four times (three FTT)
plot(type="n",x=1,y=1,xlim=c(0,800),ylim=c(0,22),
     xlab="Downstream (km)",ylab="Travel Time (days)");
axis(4, labels=F)
axis(3, at = from.zsl[-8], labels=names(from.zsl[-8]), cex.axis =0.75, las=3, hadj=-0.25)
abline(v=from.zsl[-1], col="red",lty="dotted")
for (j in fourth){
    x=858-as.numeric(obs[(j-3):j,6])
    if(any(diff(x)==0)) next; # one at same site two days.
    y=obs[(j-3):j,12] -obs[(j-3),12] # first detect = zero travel time
    lines(x,y,col=Clr)
    points(x[2:4],y[2:4],pch=20,cex=0.33)
    points(x[1],y[1],pch=20,col="red")
}
# ---- FITTING ----


# create a test dataset, recover parameters, two error models
elapsed=1:20
advect=4 # elapsed days after starting to travel
diffuse=.66  # as in standard deviation
sigma=0.2  # multiplicative normal error (%)
a=Taylor(elapsed,advect,diffuse)
observed=a*rnorm(a,1,sigma) # 20% observation error. percent.
observed=round(100*observed,0) # integer observations
a=a*sum(observed) # correct for lost mass due to rounding
plot(time,a,type="l", xlim=c(0,max(time)),
     ylim=c(0,1.1*max(c(a,observed))),
     ylab="Smolts",xlab="Elapsed Days" )
abline(v=advect) # actual
m=sum(elapsed*a)/sum(a);m;
med=elapsed[cumsum(a)/sum(a) >.5][1];med;
abline(v=c(m,med)) # mean actual

points(elapsed,observed,pch=20,cex=0.66, col="blue")
m=sum(elapsed*observed)/sum(observed);m # mean
med=elapsed[cumsum(observed)/sum(observed) >.5][1];med # median
abline(v=c(m,med), lty="dashed", col="blue") # observed

par=c(advect,diffuse,.2)
Taylor_fit_lnorm(par,observed,elapsed)
rm(o1)
o1=optim(par,fn=Taylor_fit_lnorm, observed=observed,
         elapsed=elapsed, hessian=TRUE, method="L-BFGS-B",
         lower=c(1.0,0.1,0.1));
cat("score =",  o1$value," convergence =",o1$convergence,"\n")
cat("fitted =", o1$par, " se =", H2SE(o1),"\n");
b=Taylor(elapsed,o1$par[1],o1$par[2]) * sum(observed)
lines(time,b,col="blue"); abline(v=o1$par[1],col="blue")
stdev=H2SE(o1)
txt=paste("advect=", round(o1$par[1],2), " (sd=",round(stdev[1],2),")", "  diffuse=", round(o1$par[2],2), " (sd=",round(stdev[2],2),")",sep="");
mtext(txt,3, line =0.5, col="blue")
#---- poisson fits ----

par=c(advect, diffuse)
rm(o1)
o1=optim(par,fn=Taylor_fit_poisson, observed=observed,
    elapsed=elapsed, hessian=TRUE, method="L-BFGS-B",
     lower=c(1.0,0.1));
cat("score =",  o1$value," convergence =",o1$convergence,"\n")
stdev=H2SE(o1)
txt=paste("advect=", round(o1$par[1],2), " (sd=",round(stdev[1],2),")", "  diffuse=", round(o1$par[2],2), " (sd=",round(stdev[2],2),")",sep="");
cat(txt,"\n")
b=Taylor(elapsed,o1$par[1],o1$par[2]) * sum(observed)
lines(time,b,col="red"); abline(v=o1$par[1],col="red")
mtext(txt,3, line = 1.45 ,col="red")

# ---- real fits ----
names(oneReach)# 751 of tag year site1 site2 rkm1 rkm2 doy1 doy2 sep ftt
sites.sep=data.frame( # 5 contiguous reaches
  pairs=c("ZSL–RRH","RRH–MCN","MCN-JDA","JDA–BON","BON–TWX"),    sep=c(95,293,123,113,159))
# 1 ZSL–RRH  95
# 2 RRH–MCN 293
# 3 MCN-JDA 123
# 4 JDA–BON 113
# 5 BON–TWX 159
# not included:MCN–BON 236,MCN–TWX 395,RRH–JDA 416,RRH–BON 529, RRH–TWX	688
result=data.frame(pair=NA,sep=NA,year=NA, count=NA,meanFTT=NA,sdFTT=NA,NLL=NA,advect=NA, advect.sd=NA, diffuse=NA, diffuse.sd=NA, txt=NA)
k=0
for(j in 1:5){
    pair = sites.sep$pairs[j]
    sep=sites.sep$sep[j]
    for (year in 2013:2016){
        j= oneReach$sep==sep & oneReach$year==year
        count=sum(j)
        if(count < 19) next;
cat("pair =",pair," year =",year," sep =",sep,"number=",sum(j), "\n" )
        b=table(oneReach$ftt[j]) # extract the travel times
        observed=as.vector (b) # count of paired detections
        elapsed=as.numeric(names(b)) # unique days
        mn=sum(observed*elapsed)/sum(observed); # mean FTT
        stdev=sqrt(sum(observed*(elapsed-mn)^2)/sum(observed));
        par=c(mn, 0.5) # starting guess
        o1=optim(par,fn=Taylor_fit_poisson, observed=observed,
            elapsed=elapsed, hessian=TRUE, method="L-BFGS-B",
            lower=c(1.0,0.1));
cat(" NLL =",o1$value," convergence =",o1$convergence,"\n")
        SD=Hessian_SE(o1)
        txt=paste("advect=",round(o1$par[1],2),
                  " (sd=" ,round(SD[1],2),")",
                  "  diffuse=",round(o1$par[2],2),
                  " (sd=",round(SD[2],2),")",sep="");
        cat(txt,"\n")
        k=k+1
result[k,"pair"]=pair;result[k,"sep"]=sep;result[k,"year"]=year;
result[k,"count"]=count;result[k,"meanFTT"]=mn;
result[k,"sdFTT"]=stdev; result[k,"NLL"]=o1$value;
result[k,"advect"] =o1$par[1];result[k,"advect.sd"] =SD[1];
result[k,"diffuse"]=o1$par[2];result[k,"diffuse.sd"]=SD[2];
result[k,"txt"]=txt;
    }
}
# pair = ZSL–RRH  year = 2015  sep = 95 number= 26 NLL = 10.982  convergence = 0
# advect=3.5 (sd=0.17)  diffuse=0.33 (sd=0.05)
# pair = ZSL–RRH  year = 2016  sep = 95 number= 47 NLL = 7.9348  convergence = 0
# advect=2 (sd=0.09)  diffuse=0.32 (sd=0.03)
# pair = RRH–MCN  year = 2013  sep = 293 number= 56 NLL = 12.65  convergence = 0
# advect=4.13 (sd=0.24)  diffuse=0.48 (sd=0.07)
# pair = RRH–MCN  year = 2014  sep = 293 number= 116 NLL = 12.132  convergence = 0
# advect=3.64 (sd=0.14)  diffuse=0.38 (sd=0.04)
# pair = RRH–MCN  year = 2015  sep = 293 number= 65 NLL = 19.301  convergence = 0
# advect=5.81 (sd=0.18)  diffuse=0.4 (sd=0.04)
# pair = RRH–MCN  year = 2016  sep = 293 number= 292 NLL = 46.663  convergence = 0
# advect=4.71 (sd=0.1)  diffuse=0.48 (sd=0.02)
# pair = MCN-JDA  year = 2014  sep = 123 number= 31 NLL = 12.148  convergence = 0
# advect=2.27 (sd=0.17)  diffuse=0.46 (sd=0.06)
# pair = MCN-JDA  year = 2016  sep = 123 number= 21 NLL = 10.656  convergence = 0
# advect=2.45 (sd=0.31)  diffuse=0.63 (sd=0.14)
# pair = JDA–BON  year = 2016  sep = 113 number= 26 NLL = 4.6221  convergence = 0
# advect=1.6 (sd=0.13)  diffuse=0.27 (sd=0.09)
dim(result); names(result); # 9 12
result[,c(1:5,12,6,11)] # see table in Word doc.
# ---- plot adv-diff fits ----
SetPar(); par(mfcol=c(3,3)) # 9 plots
x=1:18 ; x1=seq(.2,18,.2)
for(i in 1:dim(result)[1]){ # by rows in result
    j= oneReach$sep==result$sep[i] & oneReach$year==result$year[i]
    b=table(oneReach$ftt[j]) # extract the travel times
    observed=as.vector (b) # count of paired detections
    elapsed=as.numeric(names(b)) # unique arrival times
    plot(elapsed,observed, pch=20, xlim=c(0,13),
         ylim=c(0, 1.2*max(observed)),
         xlab="",ylab="")
    y=Taylor(x1,result$advect[i],result$diffuse[i]) * sum(observed)
    lines(x1, y)
    y=dnorm(x1,result$meanFTT[i],result$sdFTT[i])* sum(observed)
    lines(x1, y, col="blue", lty="dotted")
    legend(x=4,y=1.4*max(observed), legend=paste(result$pair[i], result$year[i]), bty="n",cex=0.75)
    axis(3,labels=F);axis(4,labels=F);
    mtext("Smolt Travel Time (days)",1,outer=T)
    mtext("Observed",2,outer=T)
}
SetPar();par(xaxs = "r",yaxs = "r")
with(result,{
  plot(meanFTT, advect,pch=20); cat(cor(meanFTT, advect)^2);# 0.994
  plot(advect,diffuse, pch=20); cat(cor(diffuse, advect)^2); # 0.030
  plot(sdFTT,diffuse,  pch=20); cat(cor(diffuse, sdFTT)^2); # 0.030
  plot(sdFTT,meanFTT,   pch=20); cat(cor(sdFTT,meanFTT)^2); #
} );
#
#
